﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.752.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var TcHmiProject1;
        (function (TcHmiProject1) {
            function SubscribeAngleChange(MyControl) {

                var width = Math.round(MyControl.getWidth() / 2);
                var height = Math.round(MyControl.getHeight() / 2);
                var currentAngle = 0;
                if (TcHmi.Server.isWebsocketReady()) {
                    var commands = [
                        {
                            'symbol': 'PLC1.MAIN.dataInt'
                        },
                    ];
                    TcHmi.Server.subscribe(commands, 1500, function (data) {

                        if (data.error !== TcHmi.Errors.NONE) {
                            return;
                        }
                        var response = data.response;
                        if (!response || response.error !== undefined) {
                            return;
                        }
                        var commands = response.commands;
                        if (commands === undefined) {
                            return;
                        }

                        for (var i = 0, ii = commands.length; i < ii; i++) {
                            var command = commands[i];
                            if (command === undefined) {
                                return;
                            }
                            if (command.error !== undefined) {
                                return;
                            }

                            if (commands[i].symbol.localeCompare('PLC1.MAIN.dataInt') == 0) {
                                currentAngle = command.readValue;

                                var t = [{
                                    "transformType": "Origin",
                                    "x": width,
                                    "xUnit": "px",
                                    "y": height,
                                    "yUnit": "px",
                                    "z": 0,
                                    "zUnit": "px",
                                }, {
                                    "transformType": "Rotate",
                                    "angle": currentAngle,
                                    "angleUnit": "deg"
                                }
                                ];
                                MyControl.setTransform(t);
                                console.log(`currentAngle = ${command.readValue}`);
                            }
                        }


                    });//subscribe

                }//websocket
            }
            TcHmiProject1.SubscribeAngleChange = SubscribeAngleChange;
        })(TcHmiProject1 = Functions.TcHmiProject1 || (Functions.TcHmiProject1 = {}));
        Functions.registerFunctionEx('SubscribeAngleChange', 'TcHmi.Functions.TcHmiProject1', TcHmiProject1.SubscribeAngleChange);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);